package com.privas.application.dto;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;

@JsonInclude(JsonInclude.Include.NON_NULL)
public class Repository {
    private MySQLRepository mysqlData;
    private CsvRepository csvData;
    private RepositoryType selectedKind;

    public Repository() {
    }

    @JsonIgnore
    public String getRepositoryName() {
        switch (selectedKind) {
            case MYSQL:
                return mysqlData.getDatabaseName();
            default:
                return "Data";
        }
    }

    public MySQLRepository getMysqlData() {
        return mysqlData;
    }

    public void setMysqlData(MySQLRepository mysqlData) {
        this.mysqlData = mysqlData;
    }

    public CsvRepository getCsvData() {
        return csvData;
    }

    public void setCsvData(CsvRepository csvData) {
        this.csvData = csvData;
    }

    public RepositoryType getSelectedKind() {
        return selectedKind;
    }

    public void setSelectedKind(RepositoryType selectedKind) {
        this.selectedKind = selectedKind;
    }
}
