package com.privas.application.dto.mapper;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ConnectionStringJDBC {
    private static Pattern pattern = Pattern.compile("jdbc:mysql:\\/\\/(.+(?:\\d+)?)\\/(.+)\\?(.+)?");
    private static Pattern patternUser = Pattern.compile("user=([^&\b]+)");
    private static Pattern patternPassword = Pattern.compile("password=([^&\b]+)");

    private String databaseName;
    private String url;
    private String port;
    private String username;
    private String password;

    public static ConnectionStringJDBC getFromString(String jdbcConnection) {
        ConnectionStringJDBC connectionStringJDBC = new ConnectionStringJDBC();
        Matcher matcher = pattern.matcher(jdbcConnection);

        if (matcher.find()) {
            String urlAndPort = matcher.group(1);
            String databaseName = matcher.group(2);
            String usernameAndPassword = null;

            if (matcher.groupCount() > 2) {
                usernameAndPassword = matcher.group(3);
            }

            connectionStringJDBC.setUrlAndPort(urlAndPort);
            connectionStringJDBC.setDatabaseName(databaseName);
            connectionStringJDBC.setUsernameAndPassword(usernameAndPassword);
        }

        return connectionStringJDBC;
    }

    private void setUrlAndPort(String urlAndPort) {
        String[] parts = urlAndPort.split(":");

        url = parts[0];

        if (parts.length > 1) {
            port = parts[1];
        } else {
            port = "3000";
        }
    }

    private void setUsernameAndPassword(String usernameAndPassword) {
        if (usernameAndPassword != null) {
            Matcher matcherUser = patternUser.matcher(usernameAndPassword);

            if (matcherUser.find()) {
                username = matcherUser.group(1);
            }

            Matcher matcherPassword = patternPassword.matcher(usernameAndPassword);

            if (matcherPassword.find()) {
                password = matcherPassword.group(1);
            }
        }
    }

    public void setDatabaseName(String databaseName) {
        this.databaseName = databaseName;
    }

    public String getDatabaseName() {
        return databaseName;
    }

    public String getUrl() {
        return url;
    }

    public String getPort() {
        return port;
    }

    public String getUsername() {
        return username;
    }

    public String getPassword() {
        return password;
    }
}

