package com.privas.application.services;

import java.util.ArrayList;
import java.util.List;

public class GeneralizationNode {
    private GeneralizationNode parent;

    private String label;
    private boolean isLeaf;
    private List<GeneralizationNode> children;

    public GeneralizationNode(GeneralizationNode parent, String label) {
        this(parent, label, false);
    }

    public GeneralizationNode(GeneralizationNode parent, String label, boolean isLeaf) {
        this.parent = parent;
        children = new ArrayList<>();
        init(label, isLeaf);
    }

    public void init(String label, boolean isLeaf) {
        this.label = label;
        this.isLeaf = isLeaf;
    }

    public void add(GeneralizationNode node) {
        if (!isLeaf) {
            this.children.add(node);
        }
    }

    public String getLabel() {
        return label;
    }

    public boolean isLeaf() {
        return isLeaf;
    }

    public GeneralizationNode getParent() {
        return parent;
    }

    public void setParent(GeneralizationNode parent) {
        this.parent = parent;
    }

    public List<GeneralizationNode> getChildren() {
        return children;
    }
}
