package com.privas.application.services;

import java.util.List;
import java.util.stream.Collectors;

public class ParserErrorMapper {

    public static List<String> mapErrors(List<ParserError> errors) {
        return errors.stream().map(ParserErrorMapper::mapError).collect(Collectors.toList());
    }

    public static String mapError(ParserError error) {
        if (error.is(ParserErrorType.MISSING_ATTACK_MODELS)) {
            return "No attack models defined. At least one should be configured";
        }
        else if (error.is(ParserErrorType.INVALID_ATTACK_MODELS_COMBINATION)) {
            return "The selected `"+ error.getValue() +"` combination is not supported. Available combinations are (recordLinkage, recordLinkage+attributeLinkage, tableLinkage+probabilisticAttack, and attributeLinkage+probabilisticAttack)";
        }
        else if (error.is(ParserErrorType.GENERALIZATION_NAME_DUPLICATED)) {
            return "The `"+ error.getValue() +"` generalization name is duplicated.";
        } else {
            return "The `"+ error.getValue() +"` generalization alias is duplicated.";
        }
    }
}
