package com.privas.application.services;

public class Range {
    private boolean leftInclusive;
    private boolean rightInclusive;
    private Double _leftValue;
    private double leftValue;
    private Double _rightValue;
    private double rightValue;

    public Range(Double leftValue, Double rightValue, boolean leftInclusive, boolean rightInclusive) {
        this._leftValue = leftValue;
        this.leftValue = leftValue == null ? Double.MIN_VALUE : leftValue;
        this._rightValue = rightValue;
        this.rightValue = rightValue == null ? rightValue.MAX_VALUE : rightValue;
        this.leftInclusive = leftInclusive;
        this.rightInclusive = rightInclusive;
    }

    public boolean isLeftInclusive() {
        return leftInclusive;
    }

    public boolean isRightInclusive() {
        return rightInclusive;
    }

    public double getLeftValue() {
        return leftValue;
    }

    public double getRightValue() {
        return rightValue;
    }

    public String toString() {
        StringBuilder stringBuilder = new StringBuilder();

        if (leftInclusive) {
            stringBuilder.append("[");
        } else {
            stringBuilder.append("]");
        }

        if (_leftValue != null) {
            stringBuilder.append(leftValue);
        }

        stringBuilder.append(",");

        if (_rightValue != null) {
            stringBuilder.append(" ").append(rightValue);
        }

        if (rightInclusive) {
            stringBuilder.append("]");
        } else {
            stringBuilder.append("[");
        }

        return stringBuilder.toString();
    }
}
