package com.privas.application.services;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class ValidatePrivacyOptions {
    private static List<List<AttackModel>> allPossibleValues = new ArrayList<>(Arrays.asList(
            Arrays.asList(AttackModel.RECORD_LINKAGE),
            Arrays.asList(AttackModel.RECORD_LINKAGE, AttackModel.ATTRIBUTE_LINKAGE),
            Arrays.asList(AttackModel.PROBABILISTIC_ATTACK),
            Arrays.asList(AttackModel.ATTRIBUTE_LINKAGE),
            Arrays.asList(AttackModel.TABLE_LINKAGE)
    ));

    public static boolean validate(List<AttackModel> attackModels) {
        boolean foundAnyPossible = false;

        for (int i = 0; i < allPossibleValues.size() && !foundAnyPossible; i++) {
            List<AttackModel> possibleValue = allPossibleValues.get(i);

            boolean possible = true;

            for (int j = 0; j < attackModels.size() && possible; j++) {
                if (!possibleValue.contains(attackModels.get(j))) {
                    possible = false;
                }
            }

            if (possible) {
                foundAnyPossible = true;
            }
        }

        return foundAnyPossible;
    }

    public static List<List<AttackModel>> getPossibleValues(List<AttackModel> attackModels) {
        List<List<AttackModel>> possibleValues = new ArrayList<>();

        for (List<AttackModel> possibleValue: allPossibleValues) {
            boolean found = false;

            for (int i = 0; i < attackModels.size() && !found; i++) {
                if (possibleValue.contains(attackModels.get(i))) {
                    found = true;
                    possibleValues.add(possibleValue);
                }
            }
        }

        return possibleValues;
    }
}
