import { NgModule } from '@angular/core';
import { Routes, RouterModule } from '@angular/router';
import { HomeComponent } from './home/home/home.component';
import { LayoutComponent } from './home/layout/layout.component';
import { LandingComponent } from './landing/landing.component';


const routes: Routes = [
  {
    path: '',
    component: LayoutComponent,
    children: [
      { path: '', pathMatch: 'full', redirectTo: 'landing' },
      { path: 'landing', component: LandingComponent }, // , canActivate: [AuthenticationGuardService] },
      { path: 'new', component: HomeComponent }, // , canActivate: [AuthenticationGuardService] },
      { path: '**', redirectTo: 'home' },
    ]
  },
  // 404 Not Found
  { path: '**', redirectTo: '' }
];

@NgModule({
  imports: [RouterModule.forRoot(routes)],
  exports: [RouterModule]
})
export class AppRoutingModule { }
