import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { FormsModule } from '@angular/forms';
import { NgxUploaderModule } from 'ngx-uploader';

import { FontAwesomeModule } from '@fortawesome/angular-fontawesome';

import { AppRoutingModule } from './app-routing.module';
import { AppComponent } from './app.component';
import { HomeComponent } from './home/home/home.component';
import { TreeComponent } from './home/tree/tree.component';
import { EntityComponent } from './home/entity/entity.component';
import { CustomMaterialModule } from './shared/custom-material/custom-material.module';
import { EntityDialogComponent } from './home/dialogs/entity-dialog/entity-dialog.component';
import { RepositoryTypesComponent } from './home/home/repository-types/repository-types.component';
import { PrivacyLevelComponent } from './home/home/privacy-level/privacy-level.component';
import { DefineEntitiesComponent } from './home/home/define-entities/define-entities.component';
import { LayoutComponent } from './home/layout/layout.component';
import { HttpClientModule } from '@angular/common/http';
import { LandingComponent } from './landing/landing.component';

@NgModule({
  declarations: [
    AppComponent,
    HomeComponent,
    TreeComponent,
    EntityComponent,
    EntityDialogComponent,
    RepositoryTypesComponent,
    PrivacyLevelComponent,
    DefineEntitiesComponent,
    LayoutComponent,
    LandingComponent
  ],
  imports: [
    BrowserModule,
    AppRoutingModule,
    BrowserAnimationsModule,
    FormsModule,
    CustomMaterialModule,
    FontAwesomeModule,
    HttpClientModule,
    NgxUploaderModule
  ],
  entryComponents: [
    EntityDialogComponent
  ],
  providers: [],
  bootstrap: [AppComponent]
})
export class AppModule { }
