import { Component, OnInit, Input, Output, EventEmitter } from '@angular/core';
import { faTrashAlt, faPencilAlt, faAsterisk, faExclamationTriangle } from '@fortawesome/free-solid-svg-icons';
import { faQuestionCircle } from '@fortawesome/free-regular-svg-icons';
import { Entity } from 'src/app/models/entity.model';

@Component({
  selector: 'app-entity',
  templateUrl: './entity.component.html',
  styleUrls: ['./entity.component.scss']
})
export class EntityComponent implements OnInit {
  faPencilAlt = faPencilAlt;
  faTrashAlt = faTrashAlt;
  faAsterisk = faAsterisk;
  faExclamationTriangle = faExclamationTriangle;
  faQuestionCircle = faQuestionCircle;

  @Input()
  data: Entity;

  @Output() edit = new EventEmitter<boolean>();
  @Output() remove = new EventEmitter<boolean>();

  taxonomies = [
    {
      name: 'gender',
    },
    {
      name: 'age',
    },
    {
      name: 'income',
    }
  ];

  ppdpTypes = [
    {
      name: 'Id',
      description: 'Identifier'
    },
    {
      name: 'QId',
      description: 'Quasi-Identifier'
    },
    {
      name: 'SA',
      description: 'Sensitive-Atribute'
    },
    {
      name: '',
      description: 'Regular attribute'
    }
  ];

  constructor() { }

  ngOnInit() {
  }

  onEdit() {
    this.edit.emit(true);
  }

  onRemove() {
    this.remove.emit(true);
  }
}
