import { Component, OnInit, Input, Output, EventEmitter } from '@angular/core';
import { PrivacyModelsService } from 'src/app/services/privacy-models.service';
import { PrivacyLevel } from 'src/app/models/privacy-level.model';

@Component({
  selector: 'app-privacy-level',
  templateUrl: './privacy-level.component.html',
  styleUrls: ['./privacy-level.component.scss']
})
export class PrivacyLevelComponent implements OnInit {

  @Input()
  privacyLevel: PrivacyLevel;

  @Output()
  nextStep = new EventEmitter<boolean>();

  @Output()
  previousStep = new EventEmitter<boolean>();

  @Input()
  overviewMode: boolean;

  constructor(private privacyModelsService: PrivacyModelsService) { }

  ngOnInit() {
  }

  onSaveAndContinue() {
    this.nextStep.emit();
  }

  onPrevious() {
    this.previousStep.emit();
  }

  toggle(index) {
    if (this.privacyLevel.availableSelection[index]) {
      this.privacyLevel.currentSelection[index] = !this.privacyLevel.currentSelection[index];

      this.privacyLevel.availableSelection =
        this.privacyModelsService.getEnabledModels(this.privacyLevel.currentSelection);
    }
  }

  anyPrivacyModelSelected(): boolean {
    return this.privacyLevel.currentSelection.some(e => e === true);
  }

}
