import { Component, OnInit, Output, EventEmitter, Input } from '@angular/core';
import { faPlug } from '@fortawesome/free-solid-svg-icons';
import { RepositoryData } from 'src/app/models/repository-data.model';

@Component({
  selector: 'app-repository-types',
  templateUrl: './repository-types.component.html',
  styleUrls: ['./repository-types.component.scss']
})
export class RepositoryTypesComponent implements OnInit {
  faPlug = faPlug;

  @Output()
  nextStep = new EventEmitter<boolean>();

  @Input()
  repositoryData: RepositoryData;

  @Input()
  overviewMode: boolean;

  constructor() { }

  ngOnInit() {
  }

  onSelectRepositoryKind(repositoryKind) {
    this.repositoryData.selectedKind = repositoryKind;
  }

  onSaveAndContinue() {
    this.nextStep.emit();
  }
}
