import { PrivacyLevel } from './privacy-level.model';
import { PrivacyModelsService } from '../services/privacy-models.service';

export class PrivacyDefinition {
    recordLinkage: boolean;
    attributeLinkage: boolean;
    tableLinkage: boolean;
    probabilisticAttack: boolean;

    constructor() {
    }

    static buildPrivacyDefinition([recordLinkage, attributeLinkage, tableLinkage, probabilisticAttack]:
        [boolean, boolean, boolean, boolean]) {
        const privacyDefinition = new PrivacyDefinition();

        privacyDefinition.recordLinkage = recordLinkage;
        privacyDefinition.attributeLinkage = attributeLinkage;
        privacyDefinition.tableLinkage = tableLinkage;
        privacyDefinition.probabilisticAttack = probabilisticAttack;

        return privacyDefinition;
    }

    static deBuildPrivacyDefinition(privacyDefinition: any, privacyLevelService: PrivacyModelsService) {
        const privacyLevel: PrivacyLevel = new PrivacyLevel();

        privacyLevel.currentSelection = [privacyDefinition.recordLinkage, privacyDefinition.attributeLinkage,
        privacyDefinition.tableLinkage, privacyDefinition.probabilisticAttack];

        privacyLevel.availableSelection = privacyLevelService.getEnabledModels(privacyLevel.currentSelection);

        return privacyLevel;
    }
}
