export class TreeData {

    constructor(leaf: boolean, beingEdited: boolean) {
        this.children = [];
        this.value = null;
        this.beingEdited = beingEdited;

        if (leaf === true) {
            this.value = '';
        }
    }
    label: string;
    value: string;
    children: TreeData[];
    beingEdited: boolean;

    static mapToTreeDatas(generalizationNodes: any[]) {
        const treeDatas = [];

        generalizationNodes.forEach(node => {
            treeDatas.push(TreeData.mapToTreeData(node));
        });

        return treeDatas;
    }

    private static mapToTreeData(node: any) {
        const treeData = new TreeData(node.leaf, false);

        treeData.label = node.label;
        treeData.value = node.value;
        treeData.children = TreeData.mapToTreeDatas(node.children);

        return treeData;
    }

    isLeaf() {
        return this.value !== null;
    }

    toggleEditMode() {
        this.beingEdited = !this.beingEdited;
    }
}
