import { Injectable } from '@angular/core';
import { MatSidenav } from '@angular/material';
import { of as observableOf } from 'rxjs';
import { BehaviorSubject } from 'rxjs';
import { Tree } from '../models/tree.model';

@Injectable({
  providedIn: 'root'
})
export class GeneralizationService {

  private sideNav: MatSidenav;

  private dataSubject: BehaviorSubject<Tree[]> = new BehaviorSubject<Tree[]>([]);

  public data$ = this.dataSubject.asObservable();

  public latestData: Tree[] = [];

  constructor() {
    this.data$.subscribe(data => {
      this.latestData = data;
    });
  }

  setSideNav(sideNav: MatSidenav) {
    this.sideNav = sideNav;
  }

  toggle() {
    this.sideNav.toggle();
  }

  publishGeneralizations(trees: any) {
    this.dataSubject.next(trees);
  }

  getGeneralizationNames() {
    const generalizationNames = [];

    this.latestData.forEach(element => {
      generalizationNames.push(element.title);
    });

    return generalizationNames;
  }
}
