import { Injectable } from '@angular/core';

@Injectable({
  providedIn: 'root'
})
export class PrivacyModelsService {
  private availableChoices = [
    [true, true, false, false],
    [false, true, false, false],
    [false, true, false, true],
    [false, false, true, false],
    [false, false, true, true]
  ];

  constructor() { }

  getEnabledModels(selection: [boolean, boolean, boolean, boolean]): [boolean, boolean, boolean, boolean] {
    const result: [boolean, boolean, boolean, boolean] = [false, false, false, false];

    if (selection.every(e => e === false)) {
      return [true, true, true, true];
    }

    result[0] = selection[0];
    result[1] = selection[1];
    result[2] = selection[2];
    result[3] = selection[3];

    this.availableChoices.forEach(row => {
      const trueIndices = [];
      selection.forEach((element, index) => {
        if (element === true) {
          trueIndices.push(index);
        }
      });

      if (trueIndices.length > 0 && trueIndices.every(index => row[index] === true)) {
        result[0] = result[0] || row[0];
        result[1] = result[1] || row[1];
        result[2] = result[2] || row[2];
        result[3] = result[3] || row[3];
      }
    });

    return result;
  }
}
